-- Author    : Draimyn - Area52 Horde
-- Edit Date : 3/08/2015
-- Verson    : 1.5

local frame = CreateFrame("Frame")

frame:RegisterEvent("PLAYER_ENTERING_WORLD");

frame:SetScript("OnEvent", function(self, event, ...)
	local isInstance = IsInInstance()                  				-- Check if Player is In an Instance
	if event == "PLAYER_ENTERING_WORLD" and isInstance then  		-- "and isInstance" Remove this before 'then' to test code without being in an instance
		local inInstanceGroup = IsInGroup(LE_PARTY_CATEGORY_INSTANCE)
		if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then				-- Check if Player is in LFG/LFR Type Group
			local currentSpec = GetSpecialization()
			local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
			local role = UnitGroupRolesAssigned("player"); 			-- Role selected or assigned in LFG 
			local spec = GetSpecialization()
			local specRole = GetSpecializationRole(spec)   			-- Current Role Specialization
			if role ~= specRole then
				local specId = GetSpecialization() 		   			-- Loot Role Info
				local spId = GetLootSpecialization()   	   			-- Loot Role Info
				local sId, spName = GetSpecializationInfoByID(spId) -- Loot Role Info
				StaticPopup_Show ("WRONG_SPEC_WARNING")    			-- Show Static PopUp from below
				playSound()								   			-- Illidan Sound File
				print("|cffffff00== SpecCheck Addon Warning: Wrong Role Active")
				print("|cff00ccff--- Active Specialization:|r ", currentSpecName)
			
				if spId == 0 then									-- Fix for Nil return When Default Loot is selected
					print("|cff00ccff--- Loot Specialization:  |r", currentSpecName)
				else
					print("|cff00ccff--- Loot Specialization:  |r" .. spName)		
				end	
				
				print("|cff00ccff--- Current Role: |r |cff00ff00", role)
				print("|cff00ccff--- Assigned Role: |r|cffff0000", specRole)
			end
		
			if role == specRole then
				local specId = GetSpecialization() 		   			-- Loot Role Info
				local spId = GetLootSpecialization()   	   			-- Loot Role Info
				local sId, spName = GetSpecializationInfoByID(spId) -- Loot Role Info
				print("|cffffff00== SpecCheck Addon Active")
				print("|cff00ccff--- Active Specialization:|r", currentSpecName)
				
				if spId == 0 then									-- Fix for Nil return When Default Loot is selected
					print("|cff00ccff--- Loot Specialization:  |r", currentSpecName)
				else
					print("|cff00ccff--- Loot Specialization:  |r" .. spName)
		
				end		
				
				print("|cff00ccff--- Current Role: |r |cff00ff00", role)
				print("|cff00ccff--- Assigned Role: |r|cff00ff00", specRole)
			end
			
		elseif IsInGroup() then										-- If Player is NOT in a LFG/LFR type group then do nothing
			return
		end
    end
end)

-- Sound file: Illidan, "You are not prepared!"
function playSound()
	PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.ogg", "Master") -- No more ".wav" accepted formats.
end

-- PopUp Warning Window
StaticPopupDialogs["WRONG_SPEC_WARNING"] = {
	text = "|cffff0000WARNING: You are in the wrong Specialization|r \n \n |cffffff00Change your Current Specialization before Combat!|r \n \n |cff00ccffWould you like to swap your talent Spec now?|r",
	button1 = "Change Talent Spec",
	button2 = "Not Right Now",
	OnAccept = function(self)
		local inLockdown = InCombatLockdown() -- Check if in combat 
		if inLockdown then
			message("|cffff0000WARNING!|r \n \n |cffffff00In combat and unable to switch specs at this time. \n Try again when combat has ended.|r")
		else	
			SetActiveSpecGroup(GetActiveSpecGroup()%2+1) -- Switches Talent Spec
		end
	end,
	showAlert = true,  -- Alert Icon in PopUp
	timeout = 0,
	whileDead = false,
	hideOnEscape = true,
	preferredIndex = 3,
}


-- Menu options section in progress below
